package net;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.concurrent.ConcurrentHashMap;


public class ListenerThread extends Thread{
	private Transport t;
	private boolean vive;
	public ListenerThread(Transport t){
		this.t = t;
		vive = true;
	}
	public void kill(){
		vive = false;
		int porta = t.getSocketEntrada().getLocalPort();
		byte[] dados = {-33};
		try {
			DatagramPacket pacoteKill = new DatagramPacket(dados, dados.length, InetAddress.getByName("localhost"),porta );
			t.getSocketSaida().send(pacoteKill);
		} catch (UnknownHostException e) {
			//faz nada
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}
	public void run(){

		while(vive){
			byte[] dados = new byte[1024];
			DatagramPacket pacote = new DatagramPacket(dados, dados.length);
			try {
				t.getSocketEntrada().receive(pacote);
			} catch (IOException e) {
				System.out.println(e.getMessage());
			}
			dados = pacote.getData();
			byte[] temp = {dados[0], dados[1],dados[2], dados[3]};
			int id = ByteOp.byteArrayToInt(temp);

			ConcurrentHashMap<Integer, Socket> tabela = t.getSockets();
			if(id != -1){ //Se for um pacote destinado a um socket
				if(tabela.containsKey(new Integer(id))){
					tabela.get(new Integer(id)).getBuffer().offer(pacote);
				}
			}else{ //Se for um pacote de probe
				byte[] dadosPacote = pacote.getData();
				int idPacote = ByteOp.byteArrayToInt(new byte[]{dadosPacote[4], dadosPacote[5], dadosPacote[6], dadosPacote[7]});
				int porta = ByteOp.byteArrayToInt(new byte[]{dadosPacote[8],dadosPacote[9], dadosPacote[10], dadosPacote[11]});
				InetAddress ip = pacote.getAddress();
				t.respond(new ConnectionInfo(idPacote, ip, porta));
			}
		}
	}
}
